package com.mr.email;

import java.awt.Color;
import java.awt.Container;
import java.awt.Font;
import java.awt.SystemColor;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.List;

import javax.swing.BorderFactory;
import javax.swing.ButtonGroup;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.SwingConstants;
import javax.swing.border.LineBorder;

/**
 * ģⷢʼ
 */
public class EmailFrame extends JFrame { // ʼ̳JFrame
	// Ա
	private JTextField addresseeTextField; // ռı
	private JTextField titleTextField; // ʼı
	private JTextArea textArea; // ʼı
	private JLabel senderLabel; // ǩ
	private JList<String> emailList; // б
	private JRadioButton normalRadio; // "ͨ"ĵѡ
	private JComboBox<String> fontComboBox; // ˵
	private JRadioButton encryptRadio;// ܷ͵ѡ
	private JButton sendBtn;// Ͱť
	private JButton saveDraftBtn;// ݸ尴ť
	private JButton switchUserBtn;// лûť
	private JCheckBox ordinaryEmailCheck;// ͨʼѡ
	private JCheckBox urgentEmailCheck;// ʼѡ
	private JCheckBox receiptCheck;// Ķִѡ

	public static void main(String[] args) {
		EmailFrame email = new EmailFrame(); // ΪemailĴ
		email.setVisible(true); // 
	}

	/**
	 * ķ
	 * 
	 * @param newEmail
	 *            ·
	 */
	public void setSenderEmail(String newEmail) {
		senderLabel.setText(newEmail);
	}

	/**
	 * ͰťռûϢ
	 */
	private void sendEmail() {
		StringBuilder sb = new StringBuilder();// ڱûıϢ
		sb.append("ռˣ").append(addresseeTextField.getText()).append("\n");
		sb.append("ʼ⣺").append(titleTextField.getText()).append("\n");

		/* жûʼ */
		sb.append("ʼͣ");
		if (ordinaryEmailCheck.isSelected()) {// "ͨʼ"ѡѡ
			sb.append(ordinaryEmailCheck.getText() + " ");// ѡеĶѡӵ
		}
		if (urgentEmailCheck.isSelected()) {
			sb.append(urgentEmailCheck.getText() + " ");
		}
		if (receiptCheck.isSelected()) {
			sb.append(receiptCheck.getText());
		}
		sb.append("\n");
		/* end:жûʼ */

		/* жûķͷʽ */
		sb.append("ͷʽ");
		if (normalRadio.isSelected()) {
			sb.append(normalRadio.getText() + " ");
		}
		if (encryptRadio.isSelected()) {
			sb.append(encryptRadio.getText());
		}
		sb.append("\n");
		/* жûķͷʽ */

		sb.append("ʼģ").append(textArea.getText());

		System.out.println(sb.toString());// ڿ̨ӡ
	}

	/*
	 * 
	 */
	public EmailFrame() { // ʼĹ췽
		setTitle("ͻˡʼ"); // öԻı
		setResizable(false); // ô岻ɸıС
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE); // ôĹرշʽ
		setBounds(100, 100, 950, 615); // ôꡢꡢ

		Container contentPane = getContentPane();// ȡ
		contentPane.setLayout(null);// Ϊֲ

		/*
		 * ͷ壬չʾͰťݸ尴ťлûť
		 */
		JPanel headPanel = new JPanel();
		// ӱ߿򣬱߿ɫΪӻڵĴڱṩıɫ߿ȣ1
		headPanel.setBorder(BorderFactory.createLineBorder(SystemColor.activeCaption, 1));
		headPanel.setBackground(SystemColor.inactiveCaption);// ӱɫɫΪǻڵĴڱṩıɫ
		headPanel.setBounds(0, 0, 944, 68);
		headPanel.setLayout(null);// Բ
		contentPane.add(headPanel);

		/*
		 * Ͱť
		 */
		sendBtn = new JButton("");// Ͱť
		sendBtn.setIcon(new ImageIcon("src/com/mr/email/send.png"));// ťͼƬ
		sendBtn.setBounds(10, 6, 56, 56);
		sendBtn.addActionListener(new ActionListener() {// Ͱť¼
			@Override
			public void actionPerformed(ActionEvent e) {
				sendEmail();
			}
		});
		headPanel.add(sendBtn);
		/*
		 * ݸ尴ť
		 */
		saveDraftBtn = new JButton();
		saveDraftBtn.setIcon(new ImageIcon("src/com/mr/email/save.png"));// ťͼƬ
		saveDraftBtn.setBounds(76, 6, 56, 56);
		headPanel.add(saveDraftBtn);
		/*
		 * лûť
		 */
		switchUserBtn = new JButton();
		switchUserBtn.setIcon(new ImageIcon("src/com/mr/email/switch.png"));
		switchUserBtn.setBounds(142, 6, 56, 56);
		switchUserBtn.addActionListener(new ActionListener() {// лûť¼
			public void actionPerformed(ActionEvent e) {
				new LoginJDialog(EmailFrame.this).setVisible(true); // ǵĶԻ
			}
		});
		headPanel.add(switchUserBtn);

		/*
		 * Ҳϵ
		 */
		JPanel contactsPanel = new JPanel();
		contactsPanel.setBackground(SystemColor.inactiveCaptionBorder);
		contactsPanel.setBorder(BorderFactory.createLineBorder(SystemColor.activeCaption));
		contactsPanel.setBounds(750, 67, 194, 519);
		contentPane.add(contactsPanel);
		contactsPanel.setLayout(null);
		/*
		 * ϵ˱
		 */
		JPanel titlePanel = new JPanel();
		titlePanel.setBorder(BorderFactory.createLineBorder(SystemColor.activeCaption));
		titlePanel.setBackground(SystemColor.inactiveCaption);
		titlePanel.setBounds(0, 0, 194, 28);
		contactsPanel.add(titlePanel);
		titlePanel.setLayout(null);
		/*
		 * ϵ˱ǩ
		 */
		JLabel contactsLabel = new JLabel("ϵ");
		contactsLabel.setForeground(new Color(0, 102, 153));
		contactsLabel.setFont(new Font("΢ź", Font.BOLD, 13));
		contactsLabel.setBounds(0, 0, 194, 28);
		titlePanel.add(contactsLabel);
		/*
		 * ϵб
		 */
		JScrollPane emailLstScroll = new JScrollPane();
		emailLstScroll.setBounds(10, 36, 174, 186);
		contactsPanel.add(emailLstScroll);

		String[] values = { "4006751066@qq.com", "zhangsan@163.com", "mingrisoft@mingrisoft.com", "53498653@qq.com",
				"mingrixueyuan@126.com", "admin@qq.com", "mrsoft@qq.com", "xiaoqiang@163.com" }; // һַ
		emailList = new JList<String>(values); // ַŵб
		emailList.setFont(new Font("Times New Roman", Font.PLAIN, 14)); // бݵʽ:ͨʽ
		emailLstScroll.setViewportView(emailList); // бŵ
		/*
		 * ռȷϰťûȷϵ˵ĵַӵռˡ
		 */
		JButton submitAddressBtn = new JButton("ȷ");
		submitAddressBtn.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				StringBuilder builder = new StringBuilder(); // ַ洢
				List<String> list = emailList.getSelectedValuesList();// ȡѡеֵ
				for (String tmp : list) {// ѡеֵ
					builder.append(tmp).append(";"); // ַ
				}
				addresseeTextField.setText(builder.toString()); // ѱѡеѡӵռ
			}
		});
		submitAddressBtn.setFont(new Font("", Font.PLAIN, 12));
		submitAddressBtn.setBounds(114, 230, 70, 23);
		contactsPanel.add(submitAddressBtn);
		/*
		 * 壬չʾռııҼı
		 */
		JPanel mainPanel = new JPanel();
		mainPanel.setBorder(new LineBorder(SystemColor.inactiveCaption));
		mainPanel.setBounds(0, 67, 751, 519);
		mainPanel.setBackground(SystemColor.inactiveCaptionBorder);
		contentPane.add(mainPanel);
		mainPanel.setLayout(null);
		/*
		 * ˱ǩ
		 */
		JLabel sendLabel = new JLabel();
		sendLabel.setIcon(new ImageIcon("src/com/mr/email/from.png"));// ӱǩͼƬ
		sendLabel.setBounds(30, 15, 65, 22);
		mainPanel.add(sendLabel);
		/*
		 * ռ˱ǩ
		 */
		JLabel receiveLabel = new JLabel();
		receiveLabel.setIcon(new ImageIcon("src/com/mr/email/to.png"));// ӱǩͼƬ
		receiveLabel.setBounds(30, 42, 65, 22);
		mainPanel.add(receiveLabel);
		/*
		 * ǩ˱ǩչʾǰ˵ַ
		 */
		senderLabel = new JLabel("976853142@XXX.com");
		senderLabel.setFont(new Font("Times New Roman", Font.PLAIN, 12));
		senderLabel.setBounds(105, 15, 616, 22);
		mainPanel.add(senderLabel);
		/*
		 * ռ˵ַıռʹá;
		 */
		addresseeTextField = new JTextField();
		addresseeTextField.setBounds(105, 42, 616, 22);
		mainPanel.add(addresseeTextField);
		addresseeTextField.setColumns(10);
		/*
		 * ʼǩ
		 */
		JLabel titleLabel = new JLabel(":");
		titleLabel.setFont(new Font("", Font.PLAIN, 13));
		titleLabel.setHorizontalAlignment(SwingConstants.RIGHT);// ıҶ
		titleLabel.setBounds(30, 69, 65, 22);
		mainPanel.add(titleLabel);
		/*
		 * ʼı
		 */
		titleTextField = new JTextField();
		titleTextField.setBounds(105, 69, 616, 22);
		mainPanel.add(titleTextField);
		titleTextField.setColumns(10);
		/*
		 * ͨʼѡ
		 */
		ordinaryEmailCheck = new JCheckBox("ͨʼ");
		ordinaryEmailCheck.setFont(new Font("", Font.PLAIN, 12));
		ordinaryEmailCheck.setBackground(SystemColor.inactiveCaptionBorder);
		ordinaryEmailCheck.setBounds(478, 100, 75, 22);
		mainPanel.add(ordinaryEmailCheck);
		/*
		 * ʼѡ
		 */
		urgentEmailCheck = new JCheckBox("ʼ");
		urgentEmailCheck.setFont(new Font("", Font.PLAIN, 12));
		urgentEmailCheck.setBackground(SystemColor.inactiveCaptionBorder);
		urgentEmailCheck.setBounds(562, 100, 75, 22);
		mainPanel.add(urgentEmailCheck);
		/*
		 * Ķִѡ
		 */
		receiptCheck = new JCheckBox("Ķִ");
		receiptCheck.setFont(new Font("", Font.PLAIN, 12));
		receiptCheck.setBackground(SystemColor.inactiveCaptionBorder);
		receiptCheck.setBounds(646, 100, 75, 22);
		mainPanel.add(receiptCheck);
		/*
		 * ͨ͵ѡť
		 */
		normalRadio = new JRadioButton("ͨ");
		normalRadio.setSelected(true);
		normalRadio.setFont(new Font("", Font.PLAIN, 12));
		normalRadio.setBackground(SystemColor.inactiveCaptionBorder);
		normalRadio.setBounds(562, 126, 75, 22);
		mainPanel.add(normalRadio);
		/*
		 * ܷ͵ѡť
		 */
		encryptRadio = new JRadioButton("ܷ");
		encryptRadio.setFont(new Font("", Font.PLAIN, 12));
		encryptRadio.setBackground(SystemColor.inactiveCaptionBorder);
		encryptRadio.setBounds(646, 126, 75, 22);
		mainPanel.add(encryptRadio);
		/*
		 * ģʽť飬ťԱͨ͵ѡťܷ͵ѡť
		 */
		ButtonGroup group = new ButtonGroup();
		group.add(normalRadio);
		group.add(encryptRadio);
		/*
		 * ʼı
		 */
		JScrollPane textAreaScroll = new JScrollPane();
		textAreaScroll.setBounds(105, 157, 616, 352);
		mainPanel.add(textAreaScroll);
		/*
		 * ʼı
		 */
		textArea = new JTextArea();
		textAreaScroll.setViewportView(textArea);
		/*
		 * ݱǩ
		 */
		JLabel contentLabel = new JLabel("ڡݣ");
		contentLabel.setFont(new Font("", Font.PLAIN, 13));
		contentLabel.setHorizontalAlignment(SwingConstants.RIGHT);
		contentLabel.setBounds(30, 324, 65, 22);
		mainPanel.add(contentLabel);
		/*
		 * ѡ˵޸ʼĸʽ
		 */
		fontComboBox = new JComboBox<String>(new String[] { "", "", "" });
		fontComboBox.setBackground(Color.WHITE);
		fontComboBox.setFont(new Font("", Font.PLAIN, 12));
		fontComboBox.setBounds(104, 113, 75, 23);
		mainPanel.add(fontComboBox);
		/*
		 * Ӧðťȷ
		 */
		JButton btnApply = new JButton("Ӧ");
		btnApply.setBounds(189, 113, 70, 23);
		btnApply.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				String selected = (String) fontComboBox.getSelectedItem();// ȡбѡеı
				switch (selected) {// жı
				case "":// ѡС塱
					textArea.setFont(new Font("", Font.PLAIN, 16));// ʼĸʽΪ塢׼壬16
					break;
				case "":
					textArea.setFont(new Font("", Font.PLAIN, 16));
					break;
				case "":
					textArea.setFont(new Font("", Font.PLAIN, 16));
					break;
				default:
					textArea.setFont(new Font("", Font.PLAIN, 16));// ʼĸʽĬΪΪ塢׼壬16
				}
			}
		});
		mainPanel.add(btnApply);
	}
}
